﻿@model ChangesViewModel
@using SiteGuide.Service
@using SiteGuide.Service.Helpers
@using SiteGuide.Web.Controllers
@using SiteGuide.Web.Helpers
@using SiteGuide.DAL.Models
@using SiteGuide.Service.Extensions
@using SiteGuide.Service.Identifiers

@if (!Model.GroupedChanges.Any())
{
    <h3>No changes.</h3>
}
@foreach (var groupedChanges in Model.GroupedChanges)
{
    <div class="card mt-2">
        <div class="card-header">
            @if (Model.ShowButtons && groupedChanges.ParentType == typeof(Site))
            {
                <div class="float-right">
                    <a class="btn btn-primary btn-sm @(groupedChanges.ParentChangeType() == ChangeType.Addition ? "disabled" : "")"
                       role="button"
                       asp-controller="Sites"
                       asp-action="Details"
                       asp-route-id="@groupedChanges.ParentKey"
                       asp-route-version="@Model.CompareToVersionId">Show Old</a>
                    <a class="btn btn-primary btn-sm @(groupedChanges.ParentChangeType() == ChangeType.Removal ? "disabled" : "")"
                       role="button"
                       asp-controller="Sites"
                       asp-action="Details"
                       asp-route-id="@groupedChanges.ParentKey"
                       asp-route-version="@(Model.ThisVersionId switch {
                            VersionIdentifier versionIdentifier => versionIdentifier.Identifier,
                            _ => null })"
                       asp-route-editVersion="@(Model.ThisVersionId switch {
                            EditVersionIdentifier editVersionIdentifier => editVersionIdentifier.Identifier,
                            _ => null })">Show New</a>

                    @if (Model.ShowEditButton)
                    {
                        <a class="btn btn-primary btn-sm" role="button"
                            asp-controller="Sites"
                            asp-action="Edit"
                            asp-route-id="@groupedChanges.ParentKey"
                            asp-route-editVersion="@(((EditVersionIdentifier)Model.ThisVersionId).IdAndVersionNumber)">Edit</a>
                    }
                </div>
            }
            @if (groupedChanges.ParentType != null)
            {
                <h5 class="card-subtitle">@AreaHelper.AreaParentageDisplay(groupedChanges.AreaParentage)</h5>
            }
            <h3>
                @switch (groupedChanges.ParentChangeType())
                {
                    case ChangeType.Edit:
                        <span class="badge badge-secondary">@groupedChanges.ParentType.Name</span>
                        break;
                    case ChangeType.Addition:
                        <span class="badge badge-success">@groupedChanges.ParentType.Name Added</span>
                        break;
                    case ChangeType.Removal:
                        <span class="badge badge-danger">@groupedChanges.ParentType.Name Deleted</span>
                        break;
                    default: throw new NotImplementedException();
                }
                @groupedChanges.ParentDescription
            </h3>
        </div>
        @if (groupedChanges.ParentChangeType() == ChangeType.Edit)
        {
            <ul class="list-group list-group-flush">
                @foreach (var changeDescriptionGroup in groupedChanges.ChangeDescriptions.GroupBy(c => new Tuple<Type, object>(c.RecordType, c.RecordKey)))
                {
                    <li class="list-group-item">
                        <div class="row">
                            <div class="@(changeDescriptionGroup.First().ChangeType == ChangeType.Edit ? "col-lg-2 col-md-3" : "col")">
                                @if (@changeDescriptionGroup.First().RecordType == typeof(Site)
                               && (changeDescriptionGroup.First().ChangeType == ChangeType.Addition || changeDescriptionGroup.First().ChangeType == ChangeType.Removal))
                                {
                                    <div class="float-right">
                                        <a class="btn btn-primary btn-sm" role="button"
                                           asp-controller="Sites"
                                           asp-action="Details"
                                           asp-route-id="@(@changeDescriptionGroup.First().RecordDescription)"
                                           asp-route-version="@(changeDescriptionGroup.First().ChangeType == ChangeType.Addition
                                                ? (Model.ThisVersionId switch { VersionIdentifier versionIdentifier => versionIdentifier.Id, _ => null })
                                                : (Model.CompareToVersionId))"
                                           asp-route-editVersion="@(changeDescriptionGroup.First().ChangeType == ChangeType.Addition ?
                                                Model.ThisVersionId switch { EditVersionIdentifier editVersionIdentifier => editVersionIdentifier.Identifier, _ => (int?)null }
                                                : null)">Show</a>
                                        
                                        @if (Model.ShowEditButton && changeDescriptionGroup.First().ChangeType == ChangeType.Addition)
                                        {
                                            if (changeDescriptionGroup.First().RecordType == typeof(Site))
                                            {
                                            <a class="btn btn-primary btn-sm"
                                                role="button"
                                                asp-controller="Sites"
                                                asp-action="Edit"
                                                asp-route-id="@changeDescriptionGroup.Key.Item2"
                                                asp-route-editVersion="@(((EditVersionIdentifier)Model.ThisVersionId).IdAndVersionNumber)">Edit</a>
                                            }
                                            // TODO: Other cases
                                        }
                                    </div>
                                }

                                @switch (changeDescriptionGroup.First().ChangeType)
                                {
                                    case ChangeType.Edit:
                                        <span class="badge badge-secondary">@changeDescriptionGroup.First().RecordType.Name.SplitCamelCase()</span>

                                        <br />
                                        break;
                                    case ChangeType.Addition:
                                        <span class="badge badge-success">@changeDescriptionGroup.First().RecordType.Name.SplitCamelCase() Added</span>
                                        break;
                                    case ChangeType.Removal:
                                        <span class="badge badge-danger">@changeDescriptionGroup.First().RecordType.Name.SplitCamelCase() Deleted</span>
                                        break;
                                    case ChangeType.Association:
                                        <span class="badge badge-success badge-outline">@changeDescriptionGroup.First().RecordType.Name.SplitCamelCase() Associated</span>
                                        break;
                                    case ChangeType.Disassociation:
                                        <span class="badge badge-danger badge-outline">@changeDescriptionGroup.First().RecordType.Name.SplitCamelCase() Disassociated</span>
                                        break;
                                    case ChangeType.AdditionAndAssociation:
                                        <span class="badge badge-success">@changeDescriptionGroup.First().RecordType.Name.SplitCamelCase() Added and Associated</span>
                                        break;
                                    case ChangeType.RemovalAndDisassociation:
                                        <span class="badge badge-danger">@changeDescriptionGroup.First().RecordType.Name.SplitCamelCase() Deleted and Disassociated</span>
                                        break;
                                }
                                @Html.Raw(changeDescriptionGroup.First().RecordDescription)
                            </div>
                            @if (changeDescriptionGroup.First().ChangeType == ChangeType.Edit)
                            {
                                <div class="col-lg-10 col-md-9">
                                    @foreach (var changeDescription in changeDescriptionGroup)
                                    {
                                        @if (changeDescription.ChangeType == ChangeType.Edit)
                                        {
                                            <p>
                                                @if (!string.IsNullOrWhiteSpace(@changeDescription.Item))
                                                {
                                                    <span class="badge badge-secondary">@changeDescription.Item.SplitCamelCase()</span>
                                                }
                                                @Html.Raw(changeDescription.Details)
                                            </p>
                                        }
                                    }
                                </div>
                            }
                        </div>
                    </li>
                }
            </ul>
        }
    </div>
}
